#include "main.h"

//͂M̒(b)
#define SIGNAL_LENGTH 0.5
//XyNg̐
#define SPECTRUM_NUM 512
//XyNg̊g啝
#define SPECTRUM_WIDTH 1
//\XyNg̍ő̑傫
//#define SPECTRUM_EXCEPT_MAX 262144000000LL
  #define SPECTRUM_EXCEPT_MAX   5000000000LL

#define ALGORIZUM_MAX 2
const char* algorizum[2]={"Ut[Gϊ","t[Gϊ"};
const cs_p func[2]={calcSpectrum,calcSpectrum_fft};

char Key[256];

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow ){
	if( ChangeWindowMode(TRUE) != DX_CHANGESCREEN_OK || DxLib_Init() == -1 ) return -1; //
	SetDrawScreen( DX_SCREEN_BACK );        //ʂɐݒ
	SetAlwaysRunFlag(TRUE);

	int pushed_f1=0;
	int pushed_f2=0;
	int sound=-1;
	
	int nowalgorizum=0;
	
	int* wavdata=NULL;
	int wavdatamax=0;
	int samplepersec=0;
	int usedata_len=0;
	int usedata_interval=0;
	int signal[SPECTRUM_NUM]={0};
	long long spectrum[SPECTRUM_NUM]={0};
	long long spectrum_max;
	
	int white=GetColor(255,255,255);
	int green=GetColor(0,255,0);
	
	
	/*fpspϐ̐錾*/
	char fpstext[1024]="0.00fps";
	unsigned long fpskizyuntick,fpsmaetime,fpsnowtime;
	int fpscount;
	
	/*fps̏*/
	fpscount=0;
	fpskizyuntick=GetTickCount();
	fpsmaetime=fpsnowtime=0;

	while(!ProcessMessage() && !ClearDrawScreen() && !GetHitKeyStateAll( Key ) && !Key[KEY_INPUT_ESCAPE]){
		//үޏ         ʂر          ްޓ͏Ԏ擾       ESCĂȂ

		//RRɏĂ
		
		//̓ǂݍ 
		if(Key[KEY_INPUT_F1]) {
			if(!pushed_f1) {
				OPENFILENAME ofn={0};
				char filename[1000]={0};
				ofn.lStructSize=sizeof(ofn);
				ofn.hwndOwner=GetMainWindowHandle();
				ofn.lpstrFilter="wavt@C(*.wav)\0*.wav\0\0";
				ofn.nFilterIndex=1;
				ofn.lpstrFile=filename;
				ofn.nMaxFile=sizeof(filename);
				ofn.lpstrTitle="Đwavt@CIĂ";
				ofn.Flags=OFN_CREATEPROMPT | OFN_FILEMUSTEXIST |
					OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST;
				if(GetOpenFileName(&ofn)) {
					unsigned char* wavfiledata;
					int fp;
					//t@Cǂݍ
					int filesize=FileRead_size(filename);
					if(filesize==-1) {
						MessageBox(GetMainWindowHandle(),
							"t@CTCY擾Ɏs܂B","G[",
							MB_OK | MB_ICONWARNING);
						goto wavopenexit;
					}
					fp=FileRead_open(filename);
					if(fp==0) {
						MessageBox(GetMainWindowHandle(),
							"t@CI[vɎs܂B","G[",
							MB_OK | MB_ICONWARNING);
						goto wavopenexit;
					}
					wavfiledata=(unsigned char*)HeapAlloc(GetProcessHeap(),0,filesize);
					if(wavfiledata==NULL) {
						MessageBox(GetMainWindowHandle(),
							"mۂɎs܂B","G[",
							MB_OK | MB_ICONWARNING);
						FileRead_close(fp);
						goto wavopenexit;
					}
					if(FileRead_read(wavfiledata,filesize,fp)==-1) {
						MessageBox(GetMainWindowHandle(),
							"t@C[hɎs܂B","G[",
							MB_OK | MB_ICONWARNING);
						FileRead_close(fp);
						HeapFree(GetProcessHeap(),0,wavfiledata);
						goto wavopenexit;
					}
					FileRead_close(fp);
					//g`f[^̓ǂݏo
					wavdatamax=getwavsamplenum(wavfiledata);
					samplepersec=getwavsamplepersecond(wavfiledata);
					if(wavdata!=NULL) {
						HeapFree(GetProcessHeap(),0,wavdata);
						wavdata=NULL;
					}
					wavdata=(int*)HeapAlloc(GetProcessHeap(),0,wavdatamax*sizeof(int));
					if(wavdata==NULL) {
						MessageBox(GetMainWindowHandle(),
							"mۂɎs܂B","G[",
							MB_OK | MB_ICONWARNING);
						FileRead_close(fp);
						HeapFree(GetProcessHeap(),0,wavfiledata);
						goto wavopenexit;
					}
					getwavdata(wavdata,wavfiledata,wavdatamax,1000);
					//wavt@Cf[^̊J
					HeapFree(GetProcessHeap(),0,wavfiledata);
					//f[^̐ݒ
					usedata_len=(int)(samplepersec*SIGNAL_LENGTH);
					usedata_interval=usedata_len/SPECTRUM_NUM; 
					//TEhf[^̓ǂݍ
					if(sound!=-1) {
						StopSoundMem(sound);
						DeleteSoundMem(sound);
						sound=-1;
					}
					sound=LoadSoundMem(filename);
					if(sound!=-1)PlaySoundMem(sound,DX_PLAYTYPE_LOOP);
					//I 
					wavopenexit:
					;
				}
			}
			pushed_f1=1;
		} else pushed_f1=0;
		
		//XyNgƏ̕` 
		if(sound!=-1) {
			//Đʒu̎擾 
			int nowpos=GetCurrentPositionSoundMem(sound);
			if(nowpos+usedata_len<=wavdatamax) {
				//f[^̍쐬
				int i;
				for(i=0;i<SPECTRUM_NUM;i++) {
					signal[i]=wavdata[nowpos+i*usedata_interval];
				}
				//XyNǧvZ 
				func[nowalgorizum](signal,SPECTRUM_NUM,spectrum);
				//XyNg̍őľvZ 
				spectrum_max=1;
				for(i=0;i<SPECTRUM_NUM;i++) {
					if(spectrum[i]>spectrum_max)spectrum_max=spectrum[i];
				}
			}
			int i,j;
			for(i=0;i<SPECTRUM_NUM;i++) {
				for(j=0;j<SPECTRUM_WIDTH;j++) {
					DrawLine(20+i*SPECTRUM_WIDTH+j,450,
						20+i*SPECTRUM_WIDTH+j,
						450-(int)(spectrum[i]*420/spectrum_max),green);
				}
			}
			DrawLine(0,30,640,30,white);
			DrawLine(0,450,640,450,white);
			DrawBox(640-(int)(640*spectrum_max/SPECTRUM_EXCEPT_MAX),
				0,640,25,green,TRUE);
			int nowcs=nowpos*100/samplepersec;
			DrawFormatString(400,10,white,"ĐʒuF%3d%2d.%02db",
				nowcs/100/60,(nowcs/100)%60,nowcs%100);
			DrawFormatString(140,10,white,"őlF%12lld",spectrum_max);
		}
		
		//ASY؂ւ 
		if(Key[KEY_INPUT_F2]) {
			if(!pushed_f2) {
				nowalgorizum++;
				if(nowalgorizum>=ALGORIZUM_MAX)nowalgorizum=0;
			}
			pushed_f2=1;
		} else pushed_f2=0;
		
		//̕`
		DrawString(10,460,"F1ŉǂݍ݁@F2ŃASY؂ւ",white);
		DrawString(400,460,algorizum[nowalgorizum],white);

		/*fpšv*/
		fpsnowtime=GetNowCount()-fpskizyuntick;
		if(fpsnowtime>=1000) {
			wsprintf(fpstext,"%d.%02dfps",
				fpscount+((1000-fpsmaetime)*100/
					(fpsnowtime-fpsmaetime))/100,
				((1000-fpsmaetime)*100/
					(fpsnowtime-fpsmaetime))%100);
			fpskizyuntick=GetNowCount();
			fpsmaetime=0;
			fpscount=0;
		} else {
			fpscount++;
			fpsmaetime=fpsnowtime;
		}
		/*fpšvI*/
		
		//fps̕`
		DrawString(10,10,fpstext,white);
		
		ScreenFlip();//ʂ\ʂɔf
	}

	DxLib_End();
	return 0;
}
