#include "main.h"

/*Ut[Gϊ*/
void calcSpectrum(const int *signal, int length, long long *spectrum) {
	int i,j;

	int N = length;

	for (i = 0; i < N; i++) {

		double a = 0, b = 0;

		for (j = 0; j < N; j++) {
			int m = j * i;

			a += cos( 2 * PHI * m / N ) * signal[j];
			b += -sin( 2 * PHI * m / N ) * signal[j];
		}

		spectrum[i] = (long long)(a * a + b * b);
	}
}
